/* $Id: def_screen.h,v 1.2 2003/10/01 17:34:35 hurtta Exp $ */

#include "headers.h"
#include "me.h"


extern int InGetPrompt;         /* set if in GetPrompt() in read() */
/* HACK */

#define pg_BOLD       0x01
#define pg_UNDERLINE  0x02
#define pg_HALFBRIGHT 0x04
#define pg_INVERSE    0x08


/* curses.c */


extern int cur_tabspacing;           /* Default? */

extern int cur_InitScreen P_((void));

extern int terminal_fd;
extern int outchar P_((int c));

extern charset_t target_display_charset;
extern struct charset_state * last_state;
extern screen_info_p  last_display_state;

extern char terminal_type[];

/* DO NOT return lines-1 (as ScreenSize() did) */

extern void cur_ScreenSize P_((int *lines, int *columns));
extern void cur_GetXYLocation P_((int *line, int *col));
extern int  cur_ClearScreen P_((void));
extern void cur_CursorUp    P_((int n));
extern void cur_CursorDown  P_((int n));
extern void cur_CursorLeft  P_((int n));
extern int cur_MoveCursor P_((int row, int col));

extern void cur_changemode P_((int *mode, int set, int reset));

/* This assumes one byte charset */
extern void cur_Writechar P_((int ch));

extern void cur_PutLineS P_((struct string *S));

extern void cur_Write_to_screen P_((const char *format, 
				    const char *msg, ...));

extern void cur_PutLine0 P_((int x, int y, const char *line));
extern void cur_PutLineX P_((int x, int y, const char *format, 
			     const char *line, ...));
extern int cur_CleartoEOLN P_((void));
extern int cur_CleartoEOS P_((void));

extern int cur_RawState P_((void));

/* NOTE: Is called from signal handler! */
extern void cur_Raw P_((int state));

void limit_position P_((int *row, int *col));

extern void transmit_functions P_((int newstate));


#if POLL_METHOD	  
extern void clear_input_buffer P_((void));  
#endif

extern int cur_ReadCh P_((int flags, int break_flag));
extern struct charset_state * cur_ReadCh2 P_((int flags,
					      int break_flag));

extern int  cursor_control;
extern int _intransmit;	        /* are we transmitting keys? */
extern char *_key_up, *_key_down, *_key_left, *_key_right,
  *_key_pageup, *_key_pagedown, *_key_home, 
  *_key_help, *_key_find;
extern char *_transmit_on,  *_transmit_off; 

/* cur_process.c */


extern void print_status P_((struct run_state *rs,int sig,int exit_code));
extern void start_run_tty_init P_((void));
extern void print_status_cooked P_((struct run_state *rs,int sig,
				    int exit_code));
/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */
